package de.fraunhofer.iem.app.kpi.strategy

import de.fraunhofer.iem.app.kpi.dto.KPIHierarchyEdgeDto

class RatioKPICalculationStrategy : de.fraunhofer.iem.app.kpi.strategy.KPICalculationStrategy {
    @Suppress("MagicNumber")
    override fun calculateKPI(children: List<KPIHierarchyEdgeDto>): Pair<Int, List<KPIHierarchyEdgeDto>> {
        if (children.size != 2) {
            throw Exception("Requires exactly two children")
        }
        // TODO: this is a dirty workaround to fix a copy by reference bug
        val copiedChildren = children.toList()
        val firstValue = children[0].to.getValue()
        val secondValue = children[1].to.getValue()
        if (firstValue >= secondValue) {
            return Pair(((secondValue.toDouble() / firstValue.toDouble()) * 100).toInt(), copiedChildren)
        }
        return Pair(((firstValue.toDouble() / secondValue.toDouble()) * 100).toInt(), copiedChildren)
    }
}
